<?php

/**
 This class contains a set of functions and variables that are common to all the
 API based subclasses.  Everyone must extend this class.
 */
class APIClass {

	// The raw NVpair output from the last action.
	protected $output = array();
	// The results of the last action (OK, FAIL, WARNING)
	public $actionResults;
	// The message from the last action
	public $actionResultsMsg;
	// A convenient combo of the two above, for logging.
	public $actionResultString;
	// A convenient true / false on success result.
	public $actionResultOk;

	/**
	 After a read, retrieve the value for a given key.
	 @param The key
	 @return The value associated with the given key.
	*/
	protected function getOutputValue ($key ) {

		foreach ($this->output as $q ) {
			$result = explode("=", $q);
			if ( strcmp($result[0], $key) == 0 ) {
				$result[1] = trim($result[1], "\"");
				$result[1] = rtrim($result[1], "\"");
				return $result[1];
			}
		}
		return "";
	}

	protected function setActionResults ( $output ) {

		$this->output = $output;

		$this->actionResults = $this->getOutputValue("actionResults");
		$this->actionResultsMsg = $this->getOutputValue("actionResultsMsg");
		$this->actionResultString = "actionResults: ".$this->actionResults." actionResultsMsg: ".
			$this->actionResultsMsg;
		if ( strcmp( $this->actionResults, "OK") == 0 ) {
			$this->actionResultOk = true;
			return;
		} 
		if ( strcmp( $this->actionResults, "WARNING") == 0 ) {
			$this->actionResultOk = true;
			return;
		} 
		$this->actionResultOk = false;

	}

	/**
	 Return the contents of this object as a string.
	 */
	public function toString() {
		return $this->output;
	}
	
	/**
	 Access the output in it's raw form.
	 For now, same as toString
	 This should go away once things are all cleaned up.
	*/
	public function getOutput () {
		return $this->output;
	}
}
