<?php


/**
 Displays a prompt, and takes a default value if the user simply hits CR 
 */
function inputText ($prompt, $default ) {
	echo ($prompt." [".$default."]: ");
	$value = fgets(STDIN);
	if ( strlen($value) <= 1 ) {
		return $default;
	}
	$value = ltrim($value);
	$value = rtrim($value);
	return $value;
}




/**
 * Given the resulting output of an API command in name=value (array) form, 
 * retrieve the value for a given key.
 * @param The output array
 * @param The key
 * @return The value associated with the given key.
*/
function getResultValue ($output, $key ) {

	foreach ($output as $q ) {
		$result = explode("=", $q);
		if ( strcmp($result[0], $key) == 0 ) {
			$result[1] = trim($result[1], "\"");
			$result[1] = rtrim($result[1], "\"");
			return $result[1];
		}
	}
	return "";
}


?>
