<?php


include_once "ReadClass.php";

class ImageDataClass extends ReadClass{

	// Test values for adding updating and reading
	// for the Imaging set of tests.
	public $mac_address = "00:0c:29:14:CA:DC";
	public $file_name = "CentOS 5.6 Backup";
	public $boot_drive = "sda";
	public $enable_provisioning_flag = "backup";
	public $backup_parameters ="-q2 -j1 -j2";
	public $restore_parameters ="-j1 -j2";

	// Read only values, do not use for comparason.
	public $authorizedTime;
	public $pxe_event_ip;
	public $pxe_event_state;
	public $pxe_event_date_time;

	// Results from data compare between two ImageDataInstances.
	public $compareString = "";
	public $equal = true;

	/**
	 Once a successful read/add/update is called, this object will be updated.
	 This method is required by any extender of ReadClass.
	*/
	protected function setValues () {

		$this->mac_address = $this->getOutputValue("mac_address");
		$this->file_name = $this->getOutputValue("file_name");
		$this->boot_drive = $this->getOutputValue("boot_drive");
		$this->enable_provisioning_flag = $this->getOutputValue("enable_provisioning_flag");
		$this->backup_parameters = $this->getOutputValue("backup_parameters");
		$this->restore_parameters = $this->getOutputValue("restore_parameters");

		// read only, do not use in a compare
		$this->authorizedTime = $this->getOutputValue("authorizedTime");
		$this->pxe_event_ip = $this->getOutputValue("pxe_event_ip");
		$this->pxe_event_state = $this->getOutputValue("pxe_event_state");
		$this->pxe_event_date_time = $this->getOutputValue("pxe_event_date_time");
	}

	/**
	 Check for equiv to another ReadData instance.  Store a string suitable for logging
	 if differences were found.  
	*/
	public function compareData( $that ) {

		$this->compareString = "";
		$this->equal = true;
		$cs = "\n";

		if ( strcmp ($this->mac_address , $that->mac_address) != 0 ) {
			$cs = $cs." the key 'mac_address' returned '".$that->mac_address.
			"' instead of '".$this->mac_address."' \n";
			$this->equal = false;
		}
		if ( strcmp ($this->file_name , $that->file_name) != 0 ) {
			$cs = $cs." the key 'file_name' returned '".$that->file_name.
			"' instead of '".$this->file_name."' \n";
			$this->equal = false;
		}
		if ( strcmp ($this->boot_drive , $that->boot_drive) != 0 ) {
			$cs = $cs." the key 'boot_drive' returned '".$that->boot_drive.
			"' instead of '".$this->boot_drive."' \n";
			$this->equal = false;
		}
		if ( strcmp ($this->enable_provisioning_flag , $that->enable_provisioning_flag) != 0 ) {
			$cs = $cs." the key 'enable_provisioning_flag' returned '".$that->enable_provisioning_flag.
			"' instead of '".$this->enable_provisioning_flag."' \n";
			$this->equal = false;
		}
		if ( strcmp ($this->backup_parameters , $that->backup_parameters) != 0 ) {
			$cs = $cs." the key 'backup_parameters' returned '".$that->backup_parameters.
			"' instead of '".$this->backup_parameters."' \n";
			$this->equal = false;
		}
		if ( strcmp ($this->restore_parameters , $that->restore_parameters) != 0 ) {
			$cs = $cs." the key 'restore_parameters' returned '".$that->restore_parameters.
			"' instead of '".$this->restore_parameters."' \n";
			$this->equal = false;
		}
		$this->compareString = $cs;

	}

	/**
	 A convenience method for setting a set of alternate values for testing Update.
	 */
	public function setAlternateValues () {


	}

	public function add ( ) {
		$this->action = "add";
		$this->actiontype = "image";
		$this->write();
	}

	public function update ( ) {
		$this->action = "update";
		$this->actiontype = "image";
		$this->write();
	}

	/**
	 Either Add or Update depending on actiontype.
	 If the operation is successful, this object's class member vars will be updated.
	 If not, it will retain the previous set of values.
	 actionResultOk will be true if success.  actionResultString contains a loggable message.
	*/
	private function write () {

		$mac_address = str_replace(":", "%3A", $this->mac_address);
		$tmpfile = "tempwget.txt";
		$command = <<< EOT
wget -qO $tmpfile --post-data 'actiontype=$this->actiontype&user_supplied_id=$this->user_supplied_id&mac_address=$mac_address&apid=$this->apid&enable_provisioning_flag=$this->enable_provisioning_flag&rtn_format=$this->rtn_format&action=$this->action&file_name=$this->file_name&boot_drive=$this->boot_drive&backup_parameters=$this->backup_parameters&restore_parameters=$this->restore_parameters' http://$this->ip/tftpboot/www/lbmp-API.php; cat $tmpfile; rm -f $tmpfile
EOT;
		$output = array();
		exec ($command, $output);
		$this->setActionResults($output);
		if ( $this->actionResultOk == true ) {
			$this->setValues();
		}

	} 

}

?>
