<?php

include_once "APIClass.php";
include_once "UserClass.php";
include_once "ImageDataClass.php";

/**

 */
class ImageRoleListClass extends APIClass {

	private $userObject;
	private $roleList = array();
	private $roleListLength = 0;
	
	function __construct($userObject) {
		$this->userObject = $userObject;
	}

	public function getRoles() {
		$ip = $this->userObject->getIP();
		$apid = $this->userObject->getTempAPID();

		$tmpfile = "tempwget.txt";
		$command = <<< EOT
wget -qO $tmpfile --post-data 'actiontype=image&apid=$apid&rtn_format=NQV&action=imageroles' http://$ip/tftpboot/www/lbmp-API.php; cat $tmpfile; rm -f $tmpfile
EOT;
		exec ($command, $output);
		$this->setActionResults($output);

		if ( $this->actionResultOk == true ) {
			$this->createRoles();
		} else {
			unset($this->roleList);
			$this->roleListLength = 0;
		}


	}

	/**
	 Read thru the list in output and construct an array of ProvisionData objects
	*/
	private function createRoles () {
		
		unset($this->roleList);

		$m = "IMAGE_ROLE_";
		$roleNum = 1;
		while (true ) {
			$user_supplied_id = $this->getOutputValue($m.$roleNum."_user_supplied_id");
			if ( strlen($user_supplied_id) == 0 ) {
				break;
			}
			// Create a new object for this list item
			$imagingRole = new ImageDataClass($this->userObject, $user_supplied_id);
			// Set all the data
			$imagingRole->mac_address = $this->getOutputValue($m.$roleNum."_mac_address");
			$imagingRole->file_name = $this->getOutputValue($m.$roleNum."_file_name");
			$imagingRole->boot_drive = $this->getOutputValue($m.$roleNum."_boot_drive");
			$imagingRole->enable_provisioning_flag = $this->getOutputValue($m.$roleNum."_enable_provisioning_flag");
			$imagingRole->backup_parameters = $this->getOutputValue($m.$roleNum."_backup_parameters");
			$imagingRole->restore_parameters = $this->getOutputValue($m.$roleNum."_restore_parameters");

			$this->roleList[$roleNum - 1] = $imagingRole;
			$roleNum = $roleNum + 1;
		}
		$this->roleListLength = $roleNum - 1;

	}

	public function getRoleListLength () {
		return $this->roleListLength;
	}
	public function getRole ($roleNum ) {
		return $this->roleList[$roleNum];
	}

	public function isRoleInList ($roleObject) {
		if ( $this->roleListLength == 0 ) {
			return false;
		}
		foreach ($this->roleList as $q ) {
			$q->compareData($roleObject);
			if ( $q->equal == true ) {
				return true;
			}
		}
		return false;
	}

	public function toString() {

		if ( $this->roleListLength == 0 ) {
			return "   Role list empty \n";
		}
		$s = "   user_id   mac_address   file_name\n";
		$i = 0;
		foreach ($this->roleList as $q ) {
			$s = $s."   ".$i." ".$q->user_supplied_id."   ".$q->mac_address."   ".
				$q->file_name."\n";
			$i = $i + 1;
		}
		return $s;

	}






}
?>
