<?php


class LoggerClass {

	// Root directory for logs.
	private $dir = "/var/log/linmin/APITest/";
	// The root filename for this logFile
	private $fileName;
	// Timestamp for the file.
	private $now;
	// Echo all logs
	private $echoOn = true;

	function __construct($fileName) {
		$this->fileName = $fileName;
		$now = shell_exec("date '+%Y-%m-%d-%H-%M-%S-'");
		$now = trim($now);
		$this->now = $now;
		$this->moveLogs();
	}

	/**
	 After a command has been executed, log success or failure of the command itself (actionResults)
	 Details will be logged to the appropriate log file.
	 @param An instance of a APIClass which has had an add, update, delete or readd done.
	 */
	public function logResult ($APIObject) {

		if ( $APIObject->actionResultOk == true ) {
			$this->logSuccess($APIObject->actionResultString);
		} else {
			$this->logFail($APIObject->actionResultString);
		}
	}

	/**
	 * This is a more primitive form of LogResult.  There are still a few places that
	 * deal with raw output instead of objects.
	 * @param The output from an action.
	 */
	public function logOutput ($output) {

		$ar = getResultValue($output, "actionResults");
		$arm = getResultValue($output, "actionResultsMsg");
		$message = "actionResults: ".$ar." actionResultsMsg: ".$arm;
		echo ($message."\n");
		if ( successful($output) == 0 ) {
			$this->logSuccess($message);
		} else {
			$this->logFail($message);
		}
	}

	/**
	 * Log a message to the success log.
	 * @param Message to log.  It will be timestamped and posted to a timestamped log file.
	 */
	public function logSuccess($message) {
		
		if ( $this->echoOn == true ) {
			echo ("Success: ".$message."\n");
		}
		$logstamp = date("Y-m-d_H:i:s");
		$logitCmd = "echo "."\"".$logstamp." ".$message."\""." >> ".$this->dir.$this->now.
			$this->fileName."Success.log";
		system($logitCmd);
	}

	/**
	 * Log a message to the fail log.
	 * @param Message to log.  It will be timestamped and posted to a timestamped log file.
	 */
	public function logFail($message) {

		if ( $this->echoOn == true ) {
			echo ("Fail: ".$message."\n");
		}
		$logstamp = date("Y-m-d_H:i:s");
		$logitCmd = "echo "."\"".$logstamp." ".$message."\""." >> ".$this->dir.$this->now.
			$this->fileName."Fail.log";
		system($logitCmd);
	}

	/**
	 * Move all existing APITest logs to the APITest directory
	 */
	private function moveLogs() {
		system("mkdir -p ".$this->dir."APIPreviousLogs/");
		system("mv  ".$this->dir."*".$this->fileName."*.log ".$this->dir."APIPreviousLogs");
	}
}

?>
