<?php


include_once "ImageDataClass.php";
include_once "ImageRoleListClass.php";
include_once "UserClass.php";
include_once "Functions.php";

// Test user_supplied_id to be used for all provisioning API tests
$user_supplied_id = "TestServer";

echo ("Welcome to the interactive Imaging Profile test tool\n\n");



// Authenticate
echo ("Attempting to authenticate...\n");
$userObject = $userObject = new UserClass("127.0.0.1", "linminapi", "baremetalapi");
if ( $userObject->actionResultOk != true ) {
	echo ("Authentication failed \n");
	echo ($userObject->actionResultString."\m");
	echo ("Exiting");
	exit (0);
}
echo ("Authentication successful.  You have five minutes. \n");

// Read in profile $user_supplied_id
$imagingProfile = new ImageDataClass($userObject, $user_supplied_id);
echo ("Attempting to read profile ".$user_supplied_id."\n");
$imagingProfile = new ImageDataClass($userObject, $user_supplied_id);
$imagingProfile->read("image");
echo ($imagingProfile->actionResultString."\n");
if ($imagingProfile->actionResultOk == true) {
	echo ("The read was successful \n");
} else {
	echo ("The read failed, see above message. \n");
}

while ( true ) {

	echo ("\n");
	echo ("Would you like to change the User Supplied ID (nick name in the GUI) ?\n");
	echo ("You are currently working with ID: ".$user_supplied_id."\n");
	echo ("If you change the ID, this program will attempt to read the associated profile data.\n");
	echo ("If a read is unsuccessful becuase the profile does not exits, \n");
	echo ("sensable default values will be set.\n");
	$value = InputText ("Change user supplied id (y/n)", "n");
	if ( strcmp( $value, "y") == 0 ) {
		$user_supplied_id = inputText ("Enter new user supplied id", $user_supplied_id);

		echo ("Attempting to read profile ".$user_supplied_id."\n");
		$imagingProfile = new ImageDataClass($userObject, $user_supplied_id);
		$imagingProfile->read("image");
		echo ($imagingProfile->actionResultString."\n");
		if ($imagingProfile->actionResultOk == true) {
			echo ("The read was successful \n");
		} else {
			echo ("The read failed, see above message. \n");
		}
		inputText("Hit return to continue", "");
	}

	echo ("------------------------------------------------------------\n");
	echo ("Current contents of profile ".$user_supplied_id."\n");
	print_r ($imagingProfile->toString() );
	echo ("------------------------------------------------------------\n\n");

	echo ("If you know the profile does not exist, choose Add.\n");
	echo ("If you know the profile does exist, choose Update or Delete..\n");

	$value = inputText ("Add a: Update u: Delete d: Exit e: ", "a");


	if ( strcmp( $value, "e") == 0 ) {
		echo ("Exiting... \n" );
		exit (0);
	}
	if ( strcmp( $value, "a") == 0 ) {
		echo ("Add \n" );
		modifyProfile();
		echo ("Attempting to add...\n");
		$imagingProfile->add();
		echo ($imagingProfile->actionResultString."\n");
	}
	if ( strcmp( $value, "u") == 0 ) {
		echo ("Update \n" );
		modifyProfile();
		echo ("Attempting to update...\n");
		$imagingProfile->update();
		echo ($imagingProfile->actionResultString."\n");
	}
	if ( strcmp( $value, "d") == 0 ) {
		$d = inputText("Are you sure you want to delete (y/n)?", "n");
		if ( strcmp( $d, "y") == 0 ) {
			echo ("Attempting to update...\n");
			$imagingProfile->delete("image");
			echo ($imagingProfile->actionResultString."\n");
		}
	}
	$value = inputText ("Exit (y/n) ", "n");
	if ( strcmp( $value, "y") == 0 ) {
		echo ("Exiting... \n" );
		exit (0);
	}
}

exit (0);

function modifyProfile () {

	global $imagingProfile;
	echo ("Verify the following data for Add or Update...\n");
	$imagingProfile->mac_address = inputText("mac_address", $imagingProfile->mac_address);
	$imagingProfile->file_name = inputText("file_name", $imagingProfile->file_name);
	$imagingProfile->boot_drive = inputText("boot_drive", $imagingProfile->boot_drive);
	$imagingProfile->enable_provisioning_flag = 
		inputText("enable_provisioning_flag (one of backup, restore, noaction)", 
		$imagingProfile->enable_provisioning_flag);
	$imagingProfile->backup_parameters = inputText("backup_parameters", $imagingProfile->backup_parameters);
	$imagingProfile->restore_parameters = inputText("restore_parameters", $imagingProfile->restore_parameters);

}



?>
