<?php

include_once "APIClass.php";
include_once "UserClass.php";
include_once "ProvisionDataClass.php";

/**

 */
class ProvisionRoleListClass extends APIClass {

	private $userObject;
	private $roleList = array();
	private $roleListLength = 0;
	
	function __construct($userObject) {
		$this->userObject = $userObject;
	}

	public function getRoles() {
		$ip = $this->userObject->getIP();
		$apid = $this->userObject->getTempAPID();

		$tmpfile = "tempwget.txt";
		$command = <<< EOT
wget -qO $tmpfile --post-data 'actiontype=provision&apid=$apid&rtn_format=NQV&action=roles' http://$ip/tftpboot/www/lbmp-API.php; cat $tmpfile; rm -f $tmpfile
EOT;
		exec ($command, $output);
		$this->setActionResults($output);

		if ( $this->actionResultOk == true ) {
			$this->createRoles();
		} else {
			unset($this->roleList);
			$this->roleListLength = 0;
		}


	}

	/**
	 Read thru the list in output and construct an array of ProvisionData objects
	*/
	private function createRoles () {
		
		unset($this->roleList);

		$m = "MAC_SPECIFIC_ROLE_";
		$roleNum = 1;
		while (true ) {
			$user_supplied_id = $this->getOutputValue($m.$roleNum."_user_supplied_id");
			if ( strlen($user_supplied_id) == 0 ) {
				break;
			}
			// Create a new object for this list item
			$provisioningRole = new ProvisionDataClass($this->userObject, $user_supplied_id);
			// Set all the data
			$provisioningRole->control_file_template = $this->getOutputValue($m.$roleNum."_control_file_template");
			$provisioningRole->mac_address = $this->getOutputValue($m.$roleNum."_mac_address");
			$provisioningRole->node_name = $this->getOutputValue($m.$roleNum."_node_name");
			$provisioningRole->node_domain = $this->getOutputValue($m.$roleNum."_node_domain");
			$provisioningRole->node_ip_address = $this->getOutputValue($m.$roleNum."_node_ip_address");
			$provisioningRole->node_subnet_mask = $this->getOutputValue($m.$roleNum."_node_subnet_mask");
			$provisioningRole->node_nameserver = $this->getOutputValue($m.$roleNum."_node_nameserver");
			$provisioningRole->node_default_gateway = $this->getOutputValue($m.$roleNum."_node_default_gateway");
			$provisioningRole->node_password = $this->getOutputValue($m.$roleNum."_node_password");
			$provisioningRole->node_time_zone = $this->getOutputValue($m.$roleNum."_node_time_zone");
			$provisioningRole->enable_provisioning_flag = $this->getOutputValue($m.$roleNum."_enable_provisioning_flag");

			$this->roleList[$roleNum - 1] = $provisioningRole;
			$roleNum = $roleNum + 1;
		}
		$this->roleListLength = $roleNum - 1;

	}

	public function getRoleListLength () {
		return $this->roleListLength;
	}
	public function getRole ($roleNum ) {
		return $this->roleList[$roleNum];
	}

	public function isRoleInList ($roleObject) {
		if ( $this->roleListLength == 0 ) {
			return false;
		}
		foreach ($this->roleList as $q ) {
			$q->compareData($roleObject);
			if ( $q->equal == true ) {
				return true;
			}
		}
		return false;
	}

	public function toString() {

		if ( $this->roleListLength == 0 ) {
			return "   Role list empty \n";
		}
		$s = "   user_id   mac_address   node_name   node_domain\n";
		$i = 0;
		foreach ($this->roleList as $q ) {
			$s = $s."   ".$i." ".$q->user_supplied_id."   ".$q->mac_address."   ".
				$q->node_name."   ".$q->node_domain."\n";
			$i = $i + 1;
		}
		return $s;

	}






}
?>
