<?php
/**
	This class is used to perform a read operation on the API.
	It stores the raw output, which can be queried for values.
*/

include_once "APIClass.php";
include_once "UserClass.php";

abstract class ReadClass extends APIClass{

	public $ip;
	public $apid;
	public $user_supplied_id;
	public $rtn_format = "NQV";
	public $action;
	public $actiontype;

	/**
	 Given an authenticated user object, create one of the Data classes.
	 @param An authenticated user.
	 */
	function __construct ( $authenticatedUserObject, $user_supplied_id ) {
		$this->ip = $authenticatedUserObject->getIP();
		$this->apid = $authenticatedUserObject->getTempAPID();
		$this->user_supplied_id = $user_supplied_id;
	}

	/**
	 Perform a read operation.
	 #param action_type = "provision" or "image"
	*/
	public function read ($action_type) {
		$this->actiontype = $action_type;
		$this->action = "read";

		$tmpfile = "tempwget.txt";
		$command = <<< EOT
wget -qO $tmpfile --post-data 'actiontype=$this->actiontype&user_supplied_id=$this->user_supplied_id&apid=$this->apid&rtn_format=$this->rtn_format&action=$this->action' http://$this->ip/tftpboot/www/lbmp-API.php; cat $tmpfile; rm -f $tmpfile
EOT;
		exec ($command, $output);
		$this->setActionResults($output);
		if ( $this->actionResultOk == true ) {
			$this->setValues();
		}
	}

	/**
	 Delete the record previously read, added, or updated.   You MUST have added, updated, or read a record
	 bedore calling this.
	 */
	public function delete ($action_type) {
		$this->actiontype = $action_type;
		$this->action = "delete";

		$tmpfile = "tempwget.txt";
	$command = <<< EOT
wget -qO $tmpfile --post-data 'actiontype=$this->actiontype&user_supplied_id=$this->user_supplied_id&apid=$this->apid&rtn_format=$this->rtn_format&action=$this->action' http://$this->ip/tftpboot/www/lbmp-API.php; cat $tmpfile; rm -f $tmpfile
EOT;

		exec ($command, $output);
		$this->output = $output;

		$ar = $this->getOutputValue("actionResults");
		$arm = $this->getOutputValue("actionResultsMsg");
		$this->actionResultString = "actionResults: ".$ar." actionResultsMsg: ".$arm;
		if ( strcmp( $ar, "OK") == 0 ) {
			$this->actionResultOk = true;
		} else {
			$this->actionResultOk = false;
		}
	}


	/**
	 Once read is called, the values from output are passed to the class member vars
	 on the subclass.  Of course only the subclass knows how to do this.
	*/
	abstract protected function setValues ();
}

?>
