<?php

include_once "APIClass.php";

/**
 This class represents a single user.  The user is automatically authenticated 
 for 5 minutes upon object construction.
 NOTE This class currently only works for the builtin user (user linminapi, password baremetal)
 */
class UserClass extends APIClass {

	public $ip;
	public $auth_user;
	public $auth_user_pw;
	public $user_apid;
	public $temp_apid;
	
	function __construct($ip, $auth_user, $auth_user_pw) {
		$this->ip = $ip;
		$this->auth_user = $auth_user;
		$this->auth_user_pw = $auth_user_pw;
		$this->getBuiltInUserAPID();
		$this->authenticate();
	}

	private function authenticate() {

		$tmpfile = "tempwget.txt";
		$command = <<< EOT
wget -qO $tmpfile --post-data 'actiontype=provision&apid=$this->user_apid&auth_user=$this->auth_user&auth_user_pw=$this->auth_user_pw&rtn_format=NQV&action=authorize' http://$this->ip/tftpboot/www/lbmp-API.php; cat $tmpfile; rm -f $tmpfile
EOT;
		exec ($command, $output);
		$this->setActionResults($output);
		if ( $this->actionResultOk == true ) {
			$this->temp_apid = $this->getOutputValue("apid");
		} else {
			$this->temp_apid = "!!!INVALID_APID!!!";
		}
	}

	/**
	 Get the user_apid for the user linminapi, password baremetal.
	 In the future, we will want to setup a different user for testing.
	 That is why the class allows user and pw to be passed in.  For now it is ignored.
	 */
	private function getBuiltInUserAPID () {

		$apiScriptUrl = "http://$this->ip/tftpboot/www/lbmp-API.php?";
		$apiScript = "/home/tftpboot/www/lbmp-API.php";
		$apiApidScript = "php /home/tftpboot/www/lbmp-API_APID_management.php";
		$this->user_apid = shell_exec($apiApidScript." allow examples | grep 'linminapi' | awk '{print $6}'");
	}

	/**
	 The the 5 minute APID that was the result of the last authentication.
	 TODDO In the future, if the apid is no longer valid, reauthenticate and then return a new one.
	 */
	public function getTempAPID () {
		return $this->temp_apid;
	}

	/**
	 Get this user's ip address.
	 */
	public function getIP () {
		return $this->ip;
	}

	/**
	 Get the perminant APID associated with this user.
	 */
	public function getUserAPID () {
		return $this->user_apid;
	}
	/**
	 Get this user's name 
	 */
	public function getUserName () {
		return $this->auth_user;
	}

	/**
	 Reauthenticate, given the settings in class member vars.
	 */
	public function reAuth() {
		$this->authenticate();
	}

}
?>
